

!!! Listing 1: SOAP-Aufruf mit Parametern

POST /StockQuote HTTP/1.1 
Host: www.stockquoteserver.com 
Content-Type: text/xml; charset="utf-8" 
Content-Length: nnnn 
SOAPAction: "Some-URI" 

<SOAP-ENV:Envelope 
  xmlns:SOAP-ENV="http://schemas.xmlSOAP.org/SOAP/envelope/" 
  SOAP-ENV:encodingStyle="http://schemas.xmlSOAP.org/SOAP/encoding/"/> 
  <SOAP-ENV:Header> 
    <t:Transaction xmlns:t="some-URI" SOAP-ENV:mustUnderstand="1">
      5
    </t:Transaction> 
  </SOAP-ENV:Header>
  <SOAP-ENV:Body> 
    <m:GetLastTradePrice xmlns:m="Some-URI"> 
      <symbol>DEF</symbol> 
      <Company>DEF Corp</Company> 
      <Price>34.1</Price> 
    </m:GetLastTradePrice> 
  </SOAP-ENV:Body> 
</SOAP-ENV:Envelope> 

!!! Listing 2 SOAP-Antwort mit Ausgabeparametern

HTTP/1.1 200 OK 
Content-Type: text/xml; charset="utf-8" 
Content-Length: nnnn 

<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlSOAP.org/SOAP/envelope/" 
 SOAP-ENV:encodingStyle="http://schemas.xmlSOAP.org/SOAP/encoding/"/> 
  <SOAP-ENV:Body> 
    <m:GetLastTradePriceResponse xmlns:m="Some-URI"> 
      <PriceAndVolume> 
        <LastTradePrice> 34.5 </LastTradePrice> 
        <DayVolume> 10000 </DayVolume> 
      </PriceAndVolume> 
    </m:GetLastTradePriceResponse> 
  </SOAP-ENV:Body> 
</SOAP-ENV:Envelope> 

!!! Listing 3: Fehlermeldung bei der Verarbeitung 

HTTP/1.1 500 Internal Server Error 
Content-Type: text/xml; charset="utf-8" 
Content-Length: nnnn 

<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlSOAP.org/SOAP/envelope/">
  <SOAP-ENV:Body> 
    <SOAP-ENV:Fault> 
      <faultcode>SOAP-ENV:Server</faultcode> 
      <faultstring>Server Error</faultstring> 
        <detail> 
          <e:myfaultdetails xmlns:e="Some-URI"> 
            <message> My application didn't work </message>
            <errorcode> 1001 </errorcode> 
          </e:myfaultdetails> 
        </detail>
    </SOAP-ENV:Fault> 
  </SOAP-ENV:Body> 
</SOAP-ENV:Envelope> 

!!! Listing 4: Hotelauskunft (Pseudo-Implementierung)

import java.util.*;

public class Hotelauskunft extends Object {
    
    public Hotelauskunft() 
    {
    }
    
    public String[] sucheHotels(
            String ort,
            Date   anreise,
            Date   abreise,
            int    anzahlEZ,
            int    maxPreisDM)
    {
	String ret[] = { "DO0001" };
	Return ret;
    }
    
    public String hotelbeschreibung(
            String hotelID)
    {
	return "Gutes Mittelklassehotel in zentraler Lage";
    }
    
    public double preisEZ(
            String hotelID)
    {
	return 89.70;
    }
}

!!! Listing 5: Beispielclient mit Apaches SOAP

import java.net.*;
import java.util.*;
import org.apache.SOAP.*;
import org.apache.SOAP.rpc.*;

public class TravelAgent extends Object {

    public static void main(String args[])
    {
        try {
            URL url = new URL("http://localhost:8080/SOAP/servlet/rpcrouter");
            String urn = "urn:hotelauskunft";
            
            Call call = new Call();
            call.setTargetObjectURI(urn);
            call.setMethodName("hotelbeschreibung");
            
            call.setEncodingStyleURI(Constants.NS_URI_SOAP_ENC);
            Vector params = new Vector();
            params.addElement(new Parameter("hotelID", String.class, "DO0001", null));
            call.setParams(params);
            
            Response resp = call.invoke(url, "");
            
            if(!resp.generatedFault()) {
                Parameter result = resp.getReturnValue();
                System.out.println("Result: " + result.getValue());
            } else {
                Fault f = resp.getFault();
                System.out.println("Fault: " + f.getFaultCode() + ", " + f.getFaultString());
            }
        } 
        catch(SOAPException se)
        {
            System.out.println("SOAPException=" + se.getFaultCode() + ", " + se.getMessage());
        }
        catch(Exception e) {
            System.out.println(e);
            e.printStackTrace();
        }
    }
}


!!! Listing 6: Hotelauskunft mit Glue

Listing 6: 
import electric.registry.Registry;
import electric.server.http.HTTP;
public class Publish1
{
public static void main( String[] args )
throws Exception
{
// startet einen Webserver anport 8004
HTTP.startup( "http://localhost:8004/glue" );
// verffentlciehn des Service Hotelasukunft
Registry.publish( "urn:hotelasukunft", new Hotelauskunft() );
}
}
